package org.antlr.tool;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import org.antlr.analysis.DFA;
import org.antlr.analysis.NFAState;
import org.antlr.misc.IntSet;
import org.antlr.runtime.CommonToken;
import org.antlr.runtime.Token;
import org.antlr.runtime.tree.CommonTree;
import org.antlr.runtime.tree.Tree;
import org.antlr.tool.ErrorManager;
import org.antlr.tool.Grammar;
import org.stringtemplate.v4.ST;

public class GrammarAST extends CommonTree {
  static int count = 0;
  
  public int ID = ++count;
  
  private String textOverride;
  
  public String enclosingRuleName;
  
  public DFA lookaheadDFA = null;
  
  public NFAState NFAStartState = null;
  
  public NFAState NFATreeDownState = null;
  
  public NFAState followingNFAState = null;
  
  protected IntSet setValue = null;
  
  protected Map<String, Object> blockOptions;
  
  public Set<org.antlr.tool.GrammarAST> rewriteRefsShallow;
  
  public Set<org.antlr.tool.GrammarAST> rewriteRefsDeep;
  
  public Map<String, Object> terminalOptions;
  
  public int outerAltNum;
  
  public ST code;
  
  public Map<String, Object> getBlockOptions() {
    return this.blockOptions;
  }
  
  public void setBlockOptions(Map<String, Object> blockOptions) {
    this.blockOptions = blockOptions;
  }
  
  public GrammarAST() {}
  
  public GrammarAST(int t, String txt) {
    initialize(t, txt);
  }
  
  public GrammarAST(Token token) {
    initialize(token);
  }
  
  public void initialize(int i, String s) {
    this.token = new CommonToken(i, s);
    this.token.setTokenIndex(-1);
  }
  
  public void initialize(Tree ast) {
    org.antlr.tool.GrammarAST t = (org.antlr.tool.GrammarAST)ast;
    this.startIndex = t.startIndex;
    this.stopIndex = t.stopIndex;
    this.token = t.token;
    this.enclosingRuleName = t.enclosingRuleName;
    this.setValue = t.setValue;
    this.blockOptions = t.blockOptions;
    this.outerAltNum = t.outerAltNum;
  }
  
  public void initialize(Token token) {
    this.token = token;
    if (token != null) {
      this.startIndex = token.getTokenIndex();
      this.stopIndex = this.startIndex;
    } 
  }
  
  public DFA getLookaheadDFA() {
    return this.lookaheadDFA;
  }
  
  public void setLookaheadDFA(DFA lookaheadDFA) {
    this.lookaheadDFA = lookaheadDFA;
  }
  
  public NFAState getNFAStartState() {
    return this.NFAStartState;
  }
  
  public void setNFAStartState(NFAState nfaStartState) {
    this.NFAStartState = nfaStartState;
  }
  
  public String setBlockOption(Grammar grammar, String key, Object value) {
    if (this.blockOptions == null)
      this.blockOptions = new HashMap<String, Object>(); 
    return setOption(this.blockOptions, Grammar.legalBlockOptions, grammar, key, value);
  }
  
  public String setTerminalOption(Grammar grammar, String key, Object value) {
    if (this.terminalOptions == null)
      this.terminalOptions = new HashMap<String, Object>(); 
    return setOption(this.terminalOptions, Grammar.legalTokenOptions, grammar, key, value);
  }
  
  public String setOption(Map<String, Object> options, Set<String> legalOptions, Grammar grammar, String key, Object value) {
    if (!legalOptions.contains(key)) {
      ErrorManager.grammarError(133, grammar, this.token, key);
      return null;
    } 
    if (value instanceof String) {
      String vs = (String)value;
      if (vs.charAt(0) == '"')
        value = vs.substring(1, vs.length() - 1); 
    } 
    if (key.equals("k"))
      grammar.numberOfManualLookaheadOptions++; 
    if (key.equals("backtrack") && value.toString().equals("true"))
      (grammar.composite.getRootGrammar()).atLeastOneBacktrackOption = true; 
    options.put(key, value);
    return key;
  }
  
  public Object getBlockOption(String key) {
    Object value = null;
    if (this.blockOptions != null)
      value = this.blockOptions.get(key); 
    return value;
  }
  
  public void setOptions(Grammar grammar, Map<String, Object> options) {
    if (options == null) {
      this.blockOptions = null;
      return;
    } 
    String[] keys = (String[])options.keySet().toArray((Object[])new String[options.size()]);
    for (String optionName : keys) {
      String stored = setBlockOption(grammar, optionName, options.get(optionName));
      if (stored == null)
        options.remove(optionName); 
    } 
  }
  
  public String getText() {
    if (this.textOverride != null)
      return this.textOverride; 
    if (this.token != null)
      return this.token.getText(); 
    return "";
  }
  
  public void setType(int type) {
    this.token.setType(type);
  }
  
  public void setText(String text) {
    this.textOverride = text;
  }
  
  public int getType() {
    if (this.token != null)
      return this.token.getType(); 
    return -1;
  }
  
  public int getLine() {
    int line = 0;
    if (this.token != null)
      line = this.token.getLine(); 
    if (line == 0) {
      Tree child = getChild(0);
      if (child != null)
        line = child.getLine(); 
    } 
    return line;
  }
  
  public int getCharPositionInLine() {
    int col = 0;
    if (this.token != null)
      col = this.token.getCharPositionInLine(); 
    if (col == 0) {
      Tree child = getChild(0);
      if (child != null)
        col = child.getCharPositionInLine(); 
    } 
    return col;
  }
  
  public void setLine(int line) {
    this.token.setLine(line);
  }
  
  public void setCharPositionInLine(int value) {
    this.token.setCharPositionInLine(value);
  }
  
  public IntSet getSetValue() {
    return this.setValue;
  }
  
  public void setSetValue(IntSet setValue) {
    this.setValue = setValue;
  }
  
  public org.antlr.tool.GrammarAST getLastChild() {
    if (getChildCount() == 0)
      return null; 
    return (org.antlr.tool.GrammarAST)getChild(getChildCount() - 1);
  }
  
  public org.antlr.tool.GrammarAST getNextSibling() {
    return (org.antlr.tool.GrammarAST)getParent().getChild(getChildIndex() + 1);
  }
  
  public org.antlr.tool.GrammarAST getLastSibling() {
    Tree parent = getParent();
    if (parent == null)
      return null; 
    return (org.antlr.tool.GrammarAST)parent.getChild(parent.getChildCount() - 1);
  }
  
  public org.antlr.tool.GrammarAST[] getChildrenAsArray() {
    List<? extends Object> children = getChildren();
    if (children == null)
      return new org.antlr.tool.GrammarAST[0]; 
    return children.<org.antlr.tool.GrammarAST>toArray(new org.antlr.tool.GrammarAST[children.size()]);
  }
  
  private static final org.antlr.tool.GrammarAST DescendantDownNode = new org.antlr.tool.GrammarAST(2, "DOWN");
  
  private static final org.antlr.tool.GrammarAST DescendantUpNode = new org.antlr.tool.GrammarAST(3, "UP");
  
  public static List<Tree> descendants(Tree root) {
    return descendants(root, false);
  }
  
  public static List<Tree> descendants(Tree root, boolean insertDownUpNodes) {
    List<Tree> result = new ArrayList<Tree>();
    int count = root.getChildCount();
    if (insertDownUpNodes) {
      result.add(root);
      result.add(DescendantDownNode);
      for (int i = 0; i < count; i++) {
        Tree child = root.getChild(i);
        for (Tree subchild : descendants(child, true))
          result.add(subchild); 
      } 
      result.add(DescendantUpNode);
    } else {
      result.add(root);
      for (int i = 0; i < count; i++) {
        Tree child = root.getChild(i);
        for (Tree subchild : descendants(child, false))
          result.add(subchild); 
      } 
    } 
    return result;
  }
  
  public org.antlr.tool.GrammarAST findFirstType(int ttype) {
    if (getType() == ttype)
      return this; 
    List<Tree> descendants = descendants(this);
    for (Tree child : descendants) {
      if (child.getType() == ttype)
        return (org.antlr.tool.GrammarAST)child; 
    } 
    return null;
  }
  
  public List<org.antlr.tool.GrammarAST> findAllType(int ttype) {
    List<org.antlr.tool.GrammarAST> nodes = new ArrayList<org.antlr.tool.GrammarAST>();
    _findAllType(ttype, nodes);
    return nodes;
  }
  
  public void _findAllType(int ttype, List<org.antlr.tool.GrammarAST> nodes) {
    if (getType() == ttype)
      nodes.add(this); 
    for (int i = 0; i < getChildCount(); i++) {
      org.antlr.tool.GrammarAST child = (org.antlr.tool.GrammarAST)getChild(i);
      child._findAllType(ttype, nodes);
    } 
  }
  
  public boolean equals(Object ast) {
    if (this == ast)
      return true; 
    if (!(ast instanceof org.antlr.tool.GrammarAST))
      return (getType() == ((Tree)ast).getType()); 
    org.antlr.tool.GrammarAST t = (org.antlr.tool.GrammarAST)ast;
    return (this.token.getLine() == t.getLine() && this.token.getCharPositionInLine() == t.getCharPositionInLine());
  }
  
  public int hashCode() {
    if (this.token == null)
      return 0; 
    return this.token.hashCode();
  }
  
  public boolean hasSameTreeStructure(Tree other) {
    if (getType() != other.getType())
      return false; 
    Iterator<Tree> thisDescendants = descendants(this, true).iterator();
    Iterator<Tree> otherDescendants = descendants(other, true).iterator();
    while (thisDescendants.hasNext()) {
      if (!otherDescendants.hasNext())
        return false; 
      if (((Tree)thisDescendants.next()).getType() != ((Tree)otherDescendants.next()).getType())
        return false; 
    } 
    return !otherDescendants.hasNext();
  }
  
  public static org.antlr.tool.GrammarAST dup(Tree t) {
    if (t == null)
      return null; 
    org.antlr.tool.GrammarAST dup_t = new org.antlr.tool.GrammarAST();
    dup_t.initialize(t);
    return dup_t;
  }
  
  public Tree dupNode() {
    return dup(this);
  }
  
  public static org.antlr.tool.GrammarAST dupTreeNoActions(org.antlr.tool.GrammarAST t, org.antlr.tool.GrammarAST parent) {
    if (t == null)
      return null; 
    org.antlr.tool.GrammarAST result = (org.antlr.tool.GrammarAST)t.dupNode();
    for (org.antlr.tool.GrammarAST subchild : getChildrenForDupTree(t))
      result.addChild(dupTreeNoActions(subchild, result)); 
    return result;
  }
  
  private static List<org.antlr.tool.GrammarAST> getChildrenForDupTree(org.antlr.tool.GrammarAST t) {
    List<org.antlr.tool.GrammarAST> result = new ArrayList<org.antlr.tool.GrammarAST>();
    for (int i = 0; i < t.getChildCount(); i++) {
      org.antlr.tool.GrammarAST child = (org.antlr.tool.GrammarAST)t.getChild(i);
      int ttype = child.getType();
      if (ttype != 76 && ttype != 75 && ttype != 4)
        if (ttype == 15 || ttype == 77) {
          for (org.antlr.tool.GrammarAST subchild : getChildrenForDupTree(child))
            result.add(subchild); 
        } else {
          result.add(child);
        }  
    } 
    if (result.size() == 1 && ((org.antlr.tool.GrammarAST)result.get(0)).getType() == 32 && t.getType() == 8)
      result.add(0, new org.antlr.tool.GrammarAST(35, "epsilon")); 
    return result;
  }
  
  public static org.antlr.tool.GrammarAST dupTree(org.antlr.tool.GrammarAST t) {
    if (t == null)
      return null; 
    org.antlr.tool.GrammarAST root = dup(t);
    for (int i = 0; i < t.getChildCount(); i++) {
      org.antlr.tool.GrammarAST child = (org.antlr.tool.GrammarAST)t.getChild(i);
      root.addChild(dupTree(child));
    } 
    return root;
  }
  
  public void setTreeEnclosingRuleNameDeeply(String rname) {
    this.enclosingRuleName = rname;
    if (getChildCount() == 0)
      return; 
    for (Object child : getChildren()) {
      if (!(child instanceof org.antlr.tool.GrammarAST))
        continue; 
      org.antlr.tool.GrammarAST grammarAST = (org.antlr.tool.GrammarAST)child;
      grammarAST.setTreeEnclosingRuleNameDeeply(rname);
    } 
  }
  
  public String toStringList() {
    String result = toStringTree();
    if (getNextSibling() != null)
      result = result + ' ' + getNextSibling().toStringList(); 
    return result;
  }
  
  public void setTokenBoundaries(Token startToken, Token stopToken) {
    if (startToken != null)
      this.startIndex = startToken.getTokenIndex(); 
    if (stopToken != null)
      this.stopIndex = stopToken.getTokenIndex(); 
  }
  
  public org.antlr.tool.GrammarAST getBlockALT(int i) {
    if (getType() != 16)
      return null; 
    int alts = 0;
    for (int j = 0; j < getChildCount(); j++) {
      if (getChild(j).getType() == 8)
        alts++; 
      if (alts == i)
        return (org.antlr.tool.GrammarAST)getChild(j); 
    } 
    return null;
  }
}
